''
'' single wire serial link - receiver
''
''        Author: Marko Lukat
'' Last modified: 2010/11/24
''       Version: 0.2
''
OBJ
  system: "core.con.system"
  
PUB null
'' This is not a top level object.

PUB init(rx)

  return cognew(@receive, rx) + 1

DAT             org     0

header_2048     long    system#ID_2             ' magic number for a cog binary
                word    header_size             ' header size
                word    %00000000_00000000      ' flags
                word    0, 0                    ' start register, register count

header_size     fit     16
                
CON
  shr_frqa_imm1 = $28FFF401                     ' shr frqa, #1
  
DAT             org     0

receive         jmpret  $, #:setup              ' once

                mov     data, seed              ' initialise LFSR

:loop           shl     data, #1 wc             ' |
        if_c    xor     data, seed              ' | advance LFSR

' prerequisites: ctra POSEDGE detector

                mov     frqa, maxx              ' preset for waitpne            (%%)
                neg     phsa, maxx              ' counter start bit effect      (%%)
                
' transfer starts, 2 start bits, 32 data bits, 1 stop bit

                waitpne mask, mask              ' wait for start bit
                waitpne frqa, #0 wr             ' bit 31, frqa += 1 in 6 cycles (%%)
                long    shr_frqa_imm1[31]       ' bit 30..0
                mov     frqa, #0                ' disable accumulation

' transfer ends

                cmp     data, phsa wz           ' validate received value
        if_nz   add     ecnt, #1                ' transmission error

                cmp     data, seed wz           '
        if_nz   jmp     #:loop                  ' continue until LFSR repeats


                mov     data, par
                add     data, #4
                wrlong  ecnt, data              ' report error count

                neg     data, #1
                sub     data, ecnt
                wrlong  data, par               ' report successful transmissions
                
                cogid   cnt                     '
                cogstop cnt                     ' sayonara ...


:setup          rdbyte  ctra, par               ' read receiver pin
                movi    ctra, #%0_01010_000     ' POSEDGE detector

                shl     mask, ctra              ' pin number -> pin mask

                wrlong  vscl, par               ' setup done
                jmp     $000                    ' ret

' initialised data and/or presets
                
ecnt            long    0                       ' transmission error count
mask            long    1                       ' pin mask (incoming data)
seed            long    $1D872B41               ' LFSR seed and xor mask
maxx            long    $7FFFFFFF               ' magic number                  (%%)

' uninitialised data and/or temporaries

data            res     1

                fit
                
DAT